local core = LibStub("AceAddon-3.0"):GetAddon("tomQuest2")
local module = core:NewModule("tooltips", "AceHook-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("tomQuest2")
local defaults = {
	profile = {
		mobtooltip = true,
		itemtooltip = true,
	},
}

local prdb
function module:OnInitialize()
	self.db = core.db:RegisterNamespace("tooltips", defaults, "Default")
	prdb = self.db.profile
end

module.modName = L["Tooltips"]
local options
function module:getOptions()
	if not options then
		options = {
			mobtooltip = {
				name = L["Toggle tooltip modification from mobs"],
				type = "toggle",
				get = function(info)
					return prdb.mobtooltip
				end,
				set = function(info, value)
					prdb.mobtooltip = value
				end,
				width = "full",
				order = 10,
			},
			itemtooltip = {
				name = L["Toggle tooltip modification from items"],
				type = "toggle",
				get = function(info)
					return prdb.itemtooltip
				end,
				set = function(info, value)
					prdb.itemtooltip = value
				end,
				width = "full",
				order = 11,
			},
		}
	end
	return options 
end

function module:OnEnable()
	self:HookScript(GameTooltip, "OnTooltipSetUnit")
	self:HookScript(GameTooltip, "OnTooltipSetItem")
end

function module:OnTooltipSetUnit(tooltip, ...)
	local name = tooltip:GetUnit()
	if name and core.questsMobs[name] and prdb.mobtooltip then
		for uid in pairs(core.questsMobs[name]) do
			tooltip:AddDoubleLine(string.format("|cffffffff%s|r", core.quests[uid].title), core.questsObjectives[uid][core.questsMobs[name][uid]].qostatus)
		end
	end
end

function module:OnTooltipSetItem(tooltip, ...)
	local name = tooltip:GetItem()
	if name and core.questsItems[name] and prdb.itemtooltip then
		for uid in pairs(core.questsItems[name]) do
			tooltip:AddDoubleLine(string.format("|cffffffff%s|r", core.quests[uid].title), core.questsObjectives[uid][core.questsItems[name][uid]].qostatus)
		end
	end
end